;##################################################################
; tabdemo
;##################################################################
#include 'tabdemo.h'
const section
IDD_TABTEST		equ 1000
IDC_TAB1		equ 1001

IDD_TAB1		equ 2000

IDD_TAB2		equ 3000

IDD_TAB3		equ 4000


data section
align 4
TCITEM	struct
	mask		dd	?
;#if (_WIN32_IE >= 0x0300)
;  DWORD  dwState;
;  DWORD  dwStateMask;
;#else 
  	lpReserved1	dd 	?
  	lpReserved2	dd	?
;#endif 
  	pszText		dd	? 
  	cchTextMax	dd 	?
  	iImage		dd	?
  	lParam	LPARAM
TCITEM ends
ts TCITEM

align 4
TabTitle1       db "Tab1",0
TabTitle2       db "Tab2",0
TabTitle3       db "Tab3",0
TabCap			db	"Message",0

align 4
hInstance		dd ?
hTab			dd ?
SelTab			dd ?

code section

start:
	
	invoke GetModuleHandle,0 
	mov	   [hInstance], eax
	invoke InitCommonControls
	invoke DialogBoxParam,[hInstance],IDD_TABTEST,NULL,addr DlgProc,NULL
	invoke ExitProcess,eax 


DlgProc frame hWnd,uMsg,wParam,lParam
	
	LOCAL	ts:TCITEM
	mov		eax,[uMsg]
	cmp		eax,WM_COMMAND
	je		>> ON_COMMAND
	cmp		eax,WM_INITDIALOG
	je		>> ON_INITDIALOG
	cmp		eax,WM_CLOSE
	je		>> ON_CLOSE
	cmp		eax,WM_NOTIFY
	je		>> ON_NOTIFY
	jmp		ret_false
	

ON_COMMAND:
		mov		eax,[wParam]
		mov		edx,eax
		and		eax,0FFFFh
		shr		edx,16
		cmp		edx,BN_CLICKED
		jnz		>> ret_false
		cmp		eax,IDCANCEL
		jnz		>
		invoke SendMessage,[hWnd],WM_CLOSE,0,0
		jmp		ret_true
:
		cmp		eax,IDOK
		jnz		>> ret_false
		invoke SendMessage,[hWnd],WM_CLOSE,0,0
		jmp		>> ret_true
		
ON_NOTIFY:
		mov		edi,[lParam]
		mov		eax,[edi+NMHDR.code]
		cmp		eax,TCN_SELCHANGE																;TCN_SELCHANGE
		jnz		>> ret_false
			;Tab selection
		invoke SendMessage,[hTab],TCM_GETCURSEL,0,0
		cmp		eax,[SelTab]
		je		>> ret_false
		push	eax
		mov		d[ts.mask],TCIF_PARAM
		invoke SendMessage,[hTab],TCM_GETITEM,[SelTab],addr ts
		invoke ShowWindow,[ts.lParam],SW_HIDE
		pop		eax
		mov		[SelTab],eax
		invoke SendMessage,[hTab],TCM_GETITEM,[SelTab],addr ts
		invoke ShowWindow,[ts.lParam],SW_SHOWDEFAULT
		
		jmp		ret_true
	
ON_INITDIALOG:
		;Create the tabs
		invoke GetDlgItem,[hWnd],IDC_TAB1
		mov		[hTab],eax
		mov		d[ts.mask],TCIF_TEXT or TCIF_PARAM
		mov		d[ts.lpReserved1],0
		mov		d[ts.lpReserved2],0
		mov		d[ts.iImage],-1

		;Create the tab dialog 1
		invoke CreateDialogParam,[hInstance],IDD_TAB1,[hTab],addr Tab1Proc,0
		;Save the dialog handle
		mov		[ts.lParam],eax
		mov		[ts.pszText],offset TabTitle1
		mov		d[ts.cchTextMax],sizeof TabTitle1
		invoke SendMessage,[hTab],TCM_INSERTITEM,0,addr ts

		;Create the tab dialog 2
		invoke CreateDialogParam,[hInstance],IDD_TAB2,[hTab],addr Tab2Proc,0
		;Save the dialog handle
		mov		[ts.lParam],eax
		mov		[ts.pszText],offset TabTitle2
		mov		d[ts.cchTextMax],sizeof TabTitle2
		invoke SendMessage,[hTab],TCM_INSERTITEM,1,addr ts

		;Create the tab dialog 3
		invoke CreateDialogParam,[hInstance],IDD_TAB3,[hTab],addr Tab3Proc,0
		;Save the dialog handle
		mov		[ts.lParam],eax
		mov		[ts.pszText],offset TabTitle3
		mov		d[ts.cchTextMax],sizeof TabTitle3
		invoke SendMessage,[hTab],TCM_INSERTITEM,2,addr ts
		jmp		ret_true
ON_CLOSE:
		invoke EndDialog,[hWnd],NULL
								
ret_true:	
		xor		eax,eax
		inc		eax
		ret
	
ret_false:
		xor		eax,eax
		ret
endf

Tab1Proc frame hWnd,uMsg,wParam,lParam
	mov	eax,[uMsg]
	cmp	eax,WM_INITDIALOG
	jnz	>
	invoke	MessageBoxEx,[hWnd],'Hello this is Tab1Proc','Message',MB_OK,0
	; do bla bla bla here
	jmp		>
	xor		eax,eax
	inc		eax								; eax is True
	ret
	
:
	xor		eax,eax							; return False
	ret		
endf


Tab2Proc FRAME hWnd,uMsg,wParam,lParam
	mov	eax,[uMsg]
	cmp	eax,WM_INITDIALOG
	jnz	>
	invoke	MessageBoxEx,[hWnd],'Hello this is Tab2Proc','Message',MB_OK,0
	; do bla bla bla here
	xor		eax,eax
	inc		eax								; eax is True
	ret
	
:
	xor		eax,eax							; return False
	ret		
endf


Tab3Proc frame hWnd,uMsg,wParam,lParam
	mov	eax,[uMsg]
	cmp	eax,WM_INITDIALOG
	jnz	>
	invoke	MessageBoxEx,[hWnd],'Hello this is Tab3Proc','Message',MB_OK,0
	; do bla bla bla here
	xor		eax,eax
	inc		eax								; eax is True
	ret
	
:
	xor		eax,eax							; return False
	ret		
endf
